// $Id: cheatah.cpp 31 2006-11-18 05:58:14Z jonmmorgan $ ($URL: http://xsword.svn.sourceforge.net/svnroot/xsword/trunk/cheatah.cpp $)
// vim:ts=4 sw=4
//
//  This program is released under the GNU GPL version 2.  For more licensing
//  information, see the file LICENSING.

#include <gtk/gtk.h>
#include "cheatsig.h"
#include "cheatah.h"
#include "unicode.h"
#include "gtk_display.h"
#include <swmgr.h>
#include <versekey.h>
#include <regex.h>
#include <string.h>
#include <iostream>
#define NDEBUG
#include <assert.h>

using sword::ModMap;
using sword::SectionMap;
using sword::ConfigEntMap;
using sword::SWKey;
using sword::VerseKey;
using sword::ListKey;
using std::string;

MainWindow *cheatahWindow = NULL;

const char *noModulesMsgConcise = "SWMgr: Can't find 'mods.conf' or 'mods.d'.  Try setting:\n\tSWORD_PATH=<directory containing mods.conf>\n\tOr see the README file for a full description of setup options.\n\t";
const char *noModulesMsg = "\nCheatah was unable to find any books installed!\n\nThey should be listed in a configuration file named either: 'mods.conf' or 'mods.d'. \n\n Try setting:\n\tSWORD_PATH=<directory containing mods.conf>\n\t Or see the README file for a full description of setup options.\n";

static const char svn_id[] = "$Id: cheatah.cpp 31 2006-11-18 05:58:14Z jonmmorgan $";

MainWindow::MainWindow() {
	searchType_group = NULL;
	mainMgr          = new SWMgr();
	curMod           = NULL;
	chapDisplay      = 0;	// set in create
	entryDisplay     = 0;	// set in create
	StringMgr::setSystemStringMgr( new GtkStringMgr() );
}

MainWindow::~MainWindow() {
	delete mainMgr;
	if (chapDisplay)
		delete chapDisplay;
	if (entryDisplay)
		delete entryDisplay;
}


GtkWidget* create_mainWindow () {
	GtkWidget *retWidget;
	cheatahWindow = new MainWindow();
	retWidget = cheatahWindow->create();
	cheatahWindow->initSWORD();
	return retWidget;
}

/*								*/
/*	Note: this seems to be a poor choice of a name for this function .	*/
/*	When  I accidentally left off the  parenthesis when trying to call it,	*/
/*	the compiler didn't complain, but it didn't execute, either.		*/
/* 	Could there be a macro or something by the same name?		*/
/*	At any rate, be careful with it.				*/
/*								*/
void destroy_mainWindow () {
	delete cheatahWindow;
}

GtkWidget *MainWindow::create() {
	mainWindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	g_object_set_data (G_OBJECT (mainWindow), "mainWindow", mainWindow);
	gtk_window_set_title (GTK_WINDOW (mainWindow), "Cheatah - SWORD Quick Lookup / Search");
	gtk_window_set_resizable (GTK_WINDOW (mainWindow), TRUE);
	gtk_window_set_default_size(GTK_WINDOW(mainWindow), 580, 360);
	g_signal_connect(G_OBJECT(mainWindow),
			"destroy",
			GTK_SIGNAL_FUNC(gtk_main_quit),
			NULL);


	mainPanel = gtk_vbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "mainPanel", mainPanel);
	gtk_widget_show (mainPanel);
	gtk_container_add (GTK_CONTAINER (mainWindow), mainPanel);

	headerPanel = gtk_hbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "headerPanel", headerPanel);
	gtk_widget_show (headerPanel);
	gtk_box_pack_start (GTK_BOX (mainPanel), headerPanel, FALSE, TRUE, 0);

	handlebox3 = gtk_handle_box_new ();
	g_object_set_data (G_OBJECT (mainWindow), "handlebox3", handlebox3);
	gtk_widget_show (handlebox3);
	gtk_box_pack_start (GTK_BOX (headerPanel), handlebox3, TRUE, TRUE, 0);

	menubar4 = gtk_menu_bar_new ();
	g_object_set_data (G_OBJECT (mainWindow), "menubar4", menubar4);
	gtk_widget_show (menubar4);
	gtk_container_add (GTK_CONTAINER (handlebox3), menubar4);

	File = gtk_menu_item_new_with_label ("File");
	g_object_set_data (G_OBJECT (mainWindow), "File", File);
	gtk_widget_show (File);
	gtk_container_add (GTK_CONTAINER (menubar4), File);

	menuFile = gtk_menu_new ();
	g_object_set_data (G_OBJECT (mainWindow), "menuFile", menuFile);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (File), menuFile);

	Exit3 = gtk_menu_item_new_with_label ("Exit");
	g_object_set_data (G_OBJECT (mainWindow), "Exit3", Exit3);
	gtk_widget_show (Exit3);
	gtk_container_add (GTK_CONTAINER (menuFile), Exit3);
	g_signal_connect (G_OBJECT (Exit3), "activate",
			GTK_SIGNAL_FUNC (gtk_main_quit),
			NULL);
	
	View3 = gtk_menu_item_new_with_label ("View");
	g_object_set_data (G_OBJECT (mainWindow), "View3", View3);
	gtk_widget_show (View3);
	gtk_container_add (GTK_CONTAINER (menubar4), View3);
	g_signal_connect (G_OBJECT (View3), "activate",
			GTK_SIGNAL_FUNC (on_View3_activate),
			NULL);

	menuView = gtk_menu_new ();
	g_object_set_data (G_OBJECT (mainWindow), "menuView", menuView);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (View3), menuView);

	commentaries = gtk_menu_item_new_with_label ("Commentaries");
	g_object_set_data (G_OBJECT (mainWindow), "commentaries", commentaries);
	gtk_widget_show (commentaries);

	menuCommentaries = gtk_menu_new ();
	g_object_set_data (G_OBJECT (mainWindow), "menuCommentaries", menuCommentaries);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (commentaries), menuCommentaries);

	dictionaries = gtk_menu_item_new_with_label ("Dictionaries");
	g_object_set_data (G_OBJECT (mainWindow), "Dictionaries", dictionaries);
	gtk_widget_show (dictionaries);

	menuDictionaries = gtk_menu_new ();
	g_object_set_data (G_OBJECT (mainWindow), "menuDictionaries", menuDictionaries);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (dictionaries), menuDictionaries);

	Help = gtk_menu_item_new_with_label ("Help");
	g_object_set_data (G_OBJECT (mainWindow), "Help", Help);
	gtk_widget_show (Help);
	gtk_container_add (GTK_CONTAINER (menubar4), Help);
	g_signal_connect (G_OBJECT (Help), "activate",
			GTK_SIGNAL_FUNC (on_Help_activate),
			NULL);
	gtk_menu_item_set_right_justified (GTK_MENU_ITEM (Help), TRUE);

	menuHelp = gtk_menu_new ();
	g_object_set_data (G_OBJECT (mainWindow), "menuHelp", menuHelp);
	gtk_menu_item_set_submenu (GTK_MENU_ITEM (Help), menuHelp);

	About = gtk_menu_item_new_with_label ("About");
	g_object_set_data (G_OBJECT (mainWindow), "About", About);
	gtk_widget_show (About);
	gtk_container_add (GTK_CONTAINER (menuHelp), About);
	g_signal_connect (G_OBJECT (About), "activate",
			GTK_SIGNAL_FUNC (on_About_activate),
			NULL);

	handlebox4 = gtk_handle_box_new ();
	g_object_set_data (G_OBJECT (mainWindow), "handlebox4", handlebox4);
	gtk_widget_show (handlebox4);
	gtk_box_pack_start (GTK_BOX (headerPanel), handlebox4, TRUE, TRUE, 0);

	hbox6 = gtk_hbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "hbox6", hbox6);
	gtk_widget_show (hbox6);
	gtk_container_add (GTK_CONTAINER (handlebox4), hbox6);

	label2 = gtk_label_new ("Reference:");
	g_object_set_data (G_OBJECT (mainWindow), "label2", label2);
	gtk_widget_show (label2);
	gtk_box_pack_start (GTK_BOX (hbox6), label2, FALSE, TRUE, 0);
	gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
	gtk_misc_set_padding (GTK_MISC (label2), 2, 0);

	lookupText = gtk_entry_new ();
	g_object_set_data (G_OBJECT (mainWindow), "lookupText", lookupText);
	gtk_widget_show (lookupText);
	gtk_box_pack_start (GTK_BOX (hbox6), lookupText, FALSE, TRUE, 0);
	g_signal_connect (G_OBJECT (lookupText), "activate",
			G_CALLBACK (on_lookupText_activated),
			NULL);

	hbox2 = gtk_hbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "hbox2", hbox2);
	gtk_widget_show (hbox2);
	gtk_box_pack_start (GTK_BOX (mainPanel), hbox2, TRUE, TRUE, 0);


	textScrolledWindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(textScrolledWindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	g_object_set_data (G_OBJECT (mainWindow), "textScrolledWindow", textScrolledWindow);
	gtk_widget_show (textScrolledWindow);

	// XXX: This is necessary to allow multiple text views using GtkDisp and tags.
	moduleTextView = GtkDisp::new_text_view();
	g_object_set_data (G_OBJECT (mainWindow), "moduleTextView", moduleTextView);
	gtk_widget_show (moduleTextView);
	gtk_container_add (GTK_CONTAINER (textScrolledWindow), moduleTextView);
	gtk_box_pack_start (GTK_BOX (hbox2), textScrolledWindow, TRUE, TRUE, 0);
	gtk_text_view_set_editable (GTK_TEXT_VIEW (moduleTextView), FALSE);
	gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (moduleTextView), GTK_WRAP_WORD);
	gtk_widget_realize (moduleTextView);

	searchPanel = gtk_vbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "searchPanel", searchPanel);
	gtk_widget_show (searchPanel);
	gtk_box_pack_start (GTK_BOX (hbox2), searchPanel, FALSE, FALSE, 0);

	hbox4 = gtk_hbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "hbox4", hbox4);
	gtk_widget_show (hbox4);
	gtk_box_pack_start (GTK_BOX (searchPanel), hbox4, FALSE, FALSE, 0);

	searchText = gtk_entry_new ();
	g_object_set_data (G_OBJECT (mainWindow), "searchText", searchText);
	gtk_widget_show (searchText);
	g_signal_connect(G_OBJECT(searchText), "activate",
			G_CALLBACK(on_search_entry_activated), NULL);
	gtk_box_pack_start (GTK_BOX (hbox4), searchText, TRUE, TRUE, 0);

	searchButton = gtk_button_new_with_label ("Search");
	g_object_set_data (G_OBJECT (mainWindow), "searchButton", searchButton);
	gtk_widget_show (searchButton);
	gtk_box_pack_start (GTK_BOX (hbox4), searchButton, FALSE, TRUE, 0);
	g_signal_connect (G_OBJECT (searchButton), "clicked",
			GTK_SIGNAL_FUNC (on_searchButton_clicked),
			NULL);

	searchSettingsPanel = gtk_hbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "searchSettingsPanel", searchSettingsPanel);
	gtk_widget_show (searchSettingsPanel);
	gtk_box_pack_start (GTK_BOX (searchPanel), searchSettingsPanel, FALSE, FALSE, 0);

	searchTypePanel = gtk_vbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "searchTypePanel", searchTypePanel);
	gtk_widget_show (searchTypePanel);
	gtk_box_pack_start (GTK_BOX (searchSettingsPanel), searchTypePanel, FALSE, FALSE, 0);

	multiWordSearch = gtk_radio_button_new_with_label (searchType_group, "Multi Word");
	searchType_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (multiWordSearch));
	g_object_set_data (G_OBJECT (mainWindow), "multiWordSearch", multiWordSearch);
	gtk_widget_show (multiWordSearch);
	gtk_box_pack_start (GTK_BOX (searchTypePanel), multiWordSearch, FALSE, FALSE, 0);

	phraseSearch = gtk_radio_button_new_with_label (searchType_group, "Exact Phrase");
	searchType_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (phraseSearch));
	g_object_set_data (G_OBJECT (mainWindow), "phraseSearch", phraseSearch);
	gtk_widget_show (phraseSearch);
	gtk_box_pack_start (GTK_BOX (searchTypePanel), phraseSearch, FALSE, FALSE, 0);

	regexSearch = gtk_radio_button_new_with_label (searchType_group, "Regular Expression");
	searchType_group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (regexSearch));
	g_object_set_data (G_OBJECT (mainWindow), "regexSearch", regexSearch);
	gtk_widget_show (regexSearch);
	gtk_box_pack_start (GTK_BOX (searchTypePanel), regexSearch, FALSE, FALSE, 0);

	searchOptionsPanel = gtk_vbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "searchOptionsPanel", searchOptionsPanel);
	gtk_widget_show (searchOptionsPanel);
	gtk_box_pack_start (GTK_BOX (searchSettingsPanel), searchOptionsPanel, FALSE, FALSE, 0);

	caseSensitive = gtk_check_button_new_with_label ("Case Sensitive");
	g_object_set_data (G_OBJECT (mainWindow), "caseSensitive", caseSensitive);
	gtk_widget_show (caseSensitive);
	gtk_box_pack_start (GTK_BOX (searchOptionsPanel), caseSensitive, FALSE, FALSE, 0);

	GtkWidget *resultPanel = gtk_hbox_new (FALSE, 0);
	g_object_set_data (G_OBJECT (mainWindow), "resultPanel", resultPanel);
	gtk_widget_show (resultPanel);
	gtk_box_pack_start (GTK_BOX (searchPanel), resultPanel, TRUE, TRUE, 0);

	resultListStore = gtk_list_store_new(1, G_TYPE_STRING);
	resultList = gtk_tree_view_new_with_model (GTK_TREE_MODEL(resultListStore));
	gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (resultList), FALSE);
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(resultList), FALSE);
	gtk_tree_view_set_search_column (GTK_TREE_VIEW (resultList), 0);
	GtkCellRenderer *renderer = gtk_cell_renderer_text_new ();
	GtkTreeViewColumn *column = gtk_tree_view_column_new_with_attributes ("",
			renderer, "text", 0, NULL);
	gtk_tree_view_append_column (GTK_TREE_VIEW(resultList), column);
	GtkWidget *sw = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (sw),
			GTK_SHADOW_ETCHED_IN);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (sw),
			GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	g_object_set_data(G_OBJECT (mainWindow), "resultList", resultList);
	gtk_container_add (GTK_CONTAINER (sw), resultList);
	gtk_widget_show (resultList);
	g_signal_connect (G_OBJECT (resultList), "row-activated",
			G_CALLBACK (on_resultList_row_activated),
			NULL);
	gtk_widget_show (sw);
	gtk_box_pack_start (GTK_BOX (resultPanel), sw, TRUE, TRUE, 0);

	arrow1 = gtk_button_new_with_label ("[<]");
	g_object_set_data (G_OBJECT (mainWindow), "arrow1", arrow1);
	gtk_widget_show (arrow1);
	gtk_box_pack_start (GTK_BOX (headerPanel), arrow1, FALSE, FALSE, 0);
	g_signal_connect (G_OBJECT (arrow1), "clicked",
			GTK_SIGNAL_FUNC (on_arrow1_button_press_event),
			NULL);

	arrow2 = gtk_button_new_with_label ("[>]");
	g_object_set_data (G_OBJECT (mainWindow), "arrow2", arrow2);
	gtk_widget_show (arrow2);
	gtk_box_pack_start (GTK_BOX (headerPanel), arrow2, FALSE, FALSE, 0);
	g_signal_connect (G_OBJECT (arrow2), "clicked",
			GTK_SIGNAL_FUNC (on_arrow2_button_press_event),
			NULL);

	statusbar1 = gtk_label_new ("");
	g_object_set_data (G_OBJECT (mainWindow), "statusbar1", statusbar1);
	gtk_widget_show (statusbar1);
	gtk_box_pack_start (GTK_BOX (mainPanel), statusbar1, FALSE, FALSE, 0);
	gtk_label_set_justify (GTK_LABEL (statusbar1), GTK_JUSTIFY_LEFT);
	gtk_misc_set_padding (GTK_MISC (statusbar1), 2, 0);

	chapDisplay = new GtkChapDisp(moduleTextView);
	entryDisplay = new GtkEntryDisp(moduleTextView);

	return mainWindow;
}

void MainWindow::initSWORD() {

	GtkWidget *menuChoice;
	int viewNumber = 1;
	char menuName[64];
	ModMap::iterator it;
	SectionMap::iterator sit;
	ConfigEntMap::iterator eit;
	char *font;
	SWModule *curMod;

/*	First, check and see whether SWMgr found any installed books.  If not, tell the user what the problem is.	*/
/*	Print a short notice to stderr, for use when the program is invoked from the command line,		*/
/*	and also put  a bit longer message into the spot where bible text would otherwise show up. 		*/
/*	Then, return out of this function, because there's nothing left to do.					*/

	if (mainMgr->Modules.empty()==TRUE) {
		GtkTextBuffer *buff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(moduleTextView));

		fprintf(stderr, noModulesMsgConcise);
		gtk_text_buffer_set_text(buff, noModulesMsg, -1);
		return;
	}

/*
*	Next, if SWMgr did find  some book modules installed , hook them up to any filters needed
*	and set up the menus to reflect them.
*	Pick a default module to show on startup.
*/
		
	for (it = mainMgr->Modules.begin(); it != mainMgr->Modules.end(); it++) {
		curMod = (*it).second;
    	menuChoice = gtk_menu_item_new_with_label (curMod->Name());
    	sprintf(menuName, "viewMod%d", viewNumber++);
    	g_object_set_data (G_OBJECT (mainWindow), menuName, menuChoice);
    	gtk_widget_show (menuChoice);
    	g_signal_connect(G_OBJECT (menuChoice), "activate",
				GTK_SIGNAL_FUNC (on_viewMod_activate),
 				g_strdup(curMod->Name()));
		if (!strcmp((*it).second->Type(), "Biblical Texts")) {
			gtk_container_add (GTK_CONTAINER (menuView), menuChoice);
			font = 0;
			if ((sit = mainMgr->config->Sections.find(curMod->Name())) != mainMgr->config->Sections.end()) {
				if ((eit = (*sit).second.find("Font")) != (*sit).second.end()) {
					font = (char *)(*eit).second.c_str();
				}
			}
			curMod->Disp(chapDisplay);	// set our GTKChapDisp object up for the diplayer of each Biblical Text module
			if (!this->curMod) 	// set currently selected module for app to first module from SWMgr (Bible Texts get first preference)
				this->curMod = curMod;
		}
		else	{
			curMod->Disp(entryDisplay);	// set our GTKEntryDisp object up for the diplayer of each module other than Biblical Texts
			if (!strcmp(curMod->Type(), "Commentaries")) {
				gtk_container_add (GTK_CONTAINER (menuCommentaries), menuChoice);
			}
			if (!strcmp(curMod->Type(), "Lexicons / Dictionaries")) {
				gtk_container_add (GTK_CONTAINER (menuDictionaries), menuChoice);
			}
		}
	}
	gtk_container_add (GTK_CONTAINER (menuView), commentaries);
	gtk_container_add (GTK_CONTAINER (menuView), dictionaries);

	if (!this->curMod)			// We didn't find a bible text, so set currently selected module for app to first module from SWMgr
		this->curMod = curMod;	// Should be o.k. to do this, because we've already tested to see if SWMgr thinks it found something
	assert(this->curMod!=NULL);
	if(this->curMod!=NULL)		// Go ahead and display default module
		lookupTextChanged();
    }

void MainWindow::lookupTextChanged() {
	string keyText;
	const gchar *entryText;
	char tmpBuf[255];
	entryText = gtk_entry_get_text(GTK_ENTRY(lookupText));
	keyText = entryText;

	if (curMod) {
		SWKey *key = curMod->CreateKey();
		VerseKey *vkey = SWDYNAMIC_CAST(VerseKey, key);
		key->Persist(1);
		if (vkey) {
			vkey->Headings(0);
			vkey->AutoNormalize(0);
		}
		*key = keyText.c_str();
		curMod->setKey(*key);

		curMod->Display();
		sprintf(tmpBuf, "%s (%s)", curMod->KeyText(), curMod->Name());
		gtk_label_set_text(GTK_LABEL(statusbar1), tmpBuf);
	}
}

void MainWindow::viewModActivate(GtkMenuItem *sender, gchar *modName) {
	ModMap::iterator it;

	it = mainMgr->Modules.find(modName);
	if (it != mainMgr->Modules.end()) {
		curMod = (*it).second;
		lookupTextChanged();
	}
	else	curMod = 0;
}


void MainWindow::navigateButtonClicked(int direction) {
	if (curMod) {
		if (direction)
			(*curMod)++;
		else	(*curMod)--;
		(const char *)*curMod;  // snap to closest locations
		const gchar *text = curMod->KeyText();
		gtk_entry_set_text(GTK_ENTRY(lookupText), text);
		curMod->Display();
	}
}

void MainWindow::searchButtonClicked() {
	string srchText;
	const gchar *entryText;
	const gchar *resultText;
	GtkTreeIter iter;

	gtk_list_store_clear(resultListStore);

	entryText = gtk_entry_get_text(GTK_ENTRY(searchText));
	srchText = entryText;

	if (curMod) {
		int searchType = GTK_TOGGLE_BUTTON(regexSearch)->active ? 0 : GTK_TOGGLE_BUTTON(phraseSearch)->active ? -1 : -2;
		int searchParams = GTK_TOGGLE_BUTTON(caseSensitive)->active ? 0 : REG_ICASE;
		for (ListKey searchResults = curMod->Search(srchText.c_str(), searchType, searchParams); !searchResults.Error(); searchResults++) {
			resultText = (const char *)searchResults;
			gtk_list_store_append(resultListStore, &iter);
			gtk_list_store_set(resultListStore, &iter, 0, resultText, -1);
		}
	}
}


void MainWindow::resultListRowActivated(GtkTreeView *view, GtkTreePath *path)	{
	gchar *text;
	GtkTreeIter iter;
	GtkTreeModel *list = GTK_TREE_MODEL(resultListStore);

	gtk_tree_model_get_iter(list, &iter, path);
	gtk_tree_model_get(list, &iter, 0, &text, -1);
	if (text) {
		gtk_entry_set_text(GTK_ENTRY(lookupText), text);
		this->lookupTextChanged();
	}
}
