// $Id: cheatsig.cpp 28 2006-07-17 13:35:38Z jonmmorgan $ ($URL: http://xsword.svn.sourceforge.net/svnroot/xsword/trunk/cheatsig.cpp $)
// vim:ts=4 sw=4
//
//  This program is released under the GNU GPL version 2.  For more licensing
//  information, see the file LICENSING.

#include <iostream>
#include <gtk/gtk.h>
#include "cheatah.h"
#include "cheatsig.h"
#include <assert.h>
using sword::ModMap;
using sword::SectionMap;
using sword::ConfigEntMap;
using std::string;

static const char svn_id[] = "$Id: cheatsig.cpp 28 2006-07-17 13:35:38Z jonmmorgan $";

int
main (int argc, char *argv[])
{
	GtkWidget *mainWindow;

	gtk_set_locale ();
	gtk_init (&argc, &argv);

	/*
	 * The following code was added by Glade to create one of each component
	 * (except popup menus), just so that you see something after building
	 * the project. Delete any components that you don't want shown initially.
	 */
	mainWindow = create_mainWindow ();
	gtk_widget_show (mainWindow);
	
	gtk_main ();

	destroy_mainWindow();
	return 0;
}


void
on_Exit3_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_View3_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_Help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_viewMod_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	cheatahWindow->viewModActivate(menuitem, (gchar *)user_data);
}


/* 
* This function is used to do a quick and dirty translation of the formating
* commands in the module descriptions into reasonable equivalents in
* plain ascii.  (The descriptions look like .rtf-lite, perhaps?)
* It takes a character pointer to the module description and
* returns a pointer to a new string that's been fixed up.  Ultimately, 
* a better solution should be developed, but this improves the 
* appearance of the descriptions significantly for now.
*
* Perhaps this could serve as the basis for a function that would take
* an input string and a text widget, then insert the string into the 
* widget in a formatted manner (good next step?);
*
* XXX: This function may not work properly in the presence of (multi-byte) UTF-8 sequences.
*/

char *
str_fixup_format		(const char *string)
{
	char	*strNew;	
	size_t 	i,j,len = strlen(string);

	assert(string!=NULL);
	strNew = (char *) malloc(len);	// First, allocate space for the new string 
	assert(strNew!=NULL);
	if(strNew==NULL) return ((char *)NULL);	// Make sure we actually got it 

	for (i=0,j=0;i<len;i++) {		// Work through input string char at a time
		if (string[i]=='\\') {			// Found backslash, probably a command
			if (string[i+1]=='q') {			// Looks like an alignment command
				if(string[i+2]=='c') {			// Want to center text 
					strNew[j]='\n';			// make do with a new line	
					j++;	
					strNew[j]='\t';			// and a tab for now
					j++;
				}
				i=i+2;				// Assume command and skip past q and ?
				continue;
			}
			else {					// if string[i+1] != 'q'
				if(string[i+1]=='p' && string[i+2]=='a' && string[i+3]=='r') {	 // "\par" or "\pard"command?
					if(string[i+4]=='d') {		 // "\pard" command - ignore for now
						i=i+4;				// Skip past the "pard"
						continue;
					}
					else {				// "\par" command
						strNew[j]='\n';			// - use a new line for now
		 				j++;
			 			i=i+3;				// Skip past the "par"
			 			continue;
					}
				}
			}					// End of "else"
		}					// End of "if(string[i]=='\\')
		strNew[j]=string[i];			// Don't know what it is, so copy it
		j++;	
	}					// End of "for"
	strNew[j]='\0';				// Terminate new string

//	fprintf(stderr, "strlen(string) = %i, strlen(strNew) = %i \n", strlen(string), strlen(strNew));	// Used for debugging
//	fprintf(stderr, "string = \"%s\"\n",string);						// Used for debugging
//	fprintf(stderr, "strNew = \"%s\"\n",strNew);						// Used for debugging

	assert(strlen(strNew)<=strlen(string));	// Nothing we have done should have lengthend it
	return(strNew);				// Return fixed-up string		
}

static void destroy_about(GtkButton *button, gpointer data)	{
	GtkWidget *window = GTK_WIDGET(data);
	gtk_widget_destroy(window);
}

void
on_About_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 	SWMgr *mainMgr;

	mainMgr=cheatahWindow->getSwordManager();
	int i;
	char *tempString;
	static const char *modtypes[] = {"Biblical Texts", "Commentaries", "Lexicons / Dictionaries"};
	string newtext, tmptext;
	ModMap::iterator it;
	SectionMap::iterator sit;
	ConfigEntMap::iterator eit;
	GtkTextBuffer *buffAboutMods, *buffAbout;

 	GtkWidget *dialogAbout = gtk_dialog_new();
	GtkWidget *hBoxModDesc;
	GtkWidget *textAboutMods;
	GtkWidget *hBoxAbout;
	GtkWidget *textAbout;
	GtkWidget *buttonOK;
	GtkWidget *sw;

	g_object_set_data (G_OBJECT (dialogAbout), "dialogAbout", dialogAbout);
	gtk_window_set_title (GTK_WINDOW (dialogAbout), "About Cheatah");
	gtk_window_set_resizable (GTK_WINDOW (dialogAbout), TRUE);
	gtk_widget_set_size_request(GTK_WIDGET(dialogAbout), 360, 360);
	gtk_window_set_position(GTK_WINDOW(dialogAbout),GTK_WIN_POS_CENTER);

	buttonOK = gtk_button_new_with_label("O.k.");

/*	Set it up so that the dialog box and all its children are automatically	*/	
/*	destroyed when the user is done looking at it.			*/
 	g_signal_connect(G_OBJECT(buttonOK),
			"clicked",
			G_CALLBACK(destroy_about),
			dialogAbout);

	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialogAbout)->action_area), buttonOK);

	sw = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show (sw);

 	hBoxModDesc = gtk_hbox_new (FALSE,0);
	g_object_set_data (G_OBJECT (dialogAbout), "hBoxModDesc", hBoxModDesc);
	gtk_box_pack_end (GTK_BOX (GTK_DIALOG(dialogAbout)->vbox), hBoxModDesc, TRUE, TRUE, 0);
	textAboutMods = gtk_text_view_new ();
	buffAboutMods = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textAboutMods));
 	g_object_set_data (G_OBJECT (dialogAbout), "textAboutMods", textAboutMods);
	gtk_container_add (GTK_CONTAINER (sw), textAboutMods);
	gtk_box_pack_start (GTK_BOX (hBoxModDesc), sw, TRUE, TRUE, 0);
	gtk_text_view_set_editable (GTK_TEXT_VIEW (textAboutMods), FALSE);
	gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textAboutMods), GTK_WRAP_WORD);


	if (mainMgr->Modules.empty()==TRUE) {
		gtk_text_buffer_set_text(buffAboutMods, noModulesMsg, -1);
	}
	else {
		GtkTextIter end;
		gtk_text_buffer_get_end_iter(buffAboutMods, &end);
		gtk_text_buffer_insert(buffAboutMods, &end, "\tInstalled Book Modules", -1);
		for (i = 0; i < 3; i++) {
			gtk_text_buffer_insert(buffAboutMods, &end, "\n\n\t", -1);
			text_buffer_insert_utf8_validate(buffAboutMods, &end, modtypes[i], -1);
			gtk_text_buffer_insert(buffAboutMods, &end, "\n\n", -1);
			for (it = mainMgr->Modules.begin(); it != mainMgr->Modules.end(); it++) {
				if (!strcmp((*it).second->Type(), modtypes[i])) {
					sit = mainMgr->config->Sections.find((*it).second->Name());
					if (sit != mainMgr->config->Sections.end()) {
						text_buffer_insert_utf8_validate(buffAboutMods, &end, (*it).second->Name() ,-1);
						gtk_text_buffer_insert(buffAboutMods, &end, ": " ,-1);
						text_buffer_insert_utf8_validate(buffAboutMods, &end, (*it).second->Description() ,-1);
						gtk_text_buffer_insert(buffAboutMods, &end, "\n\n", -1);
						eit = (*sit).second.find("About");
						if (eit != (*sit).second.end()) {
							tempString=str_fixup_format((*eit).second.c_str() );
							text_buffer_insert_utf8_validate(buffAboutMods, &end, tempString, -1);
							free(tempString);
							gtk_text_buffer_insert(buffAboutMods, &end, "\n\n" ,-1);
						}
					}
				}
			}
		}
	}

	sw = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(sw), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show (sw);
 
	hBoxAbout = gtk_hbox_new (FALSE,0);
	g_object_set_data (G_OBJECT (dialogAbout), "hBoxAbout", hBoxAbout);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG(dialogAbout)->vbox), hBoxAbout, FALSE, TRUE, 0);
	textAbout = gtk_text_view_new ();
 	g_object_set_data (G_OBJECT (dialogAbout), "textAbout", textAbout);
	buffAbout = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textAbout));
	gtk_container_add (GTK_CONTAINER (sw), textAbout);
	gtk_box_pack_start (GTK_BOX (hBoxAbout), sw, TRUE, TRUE, 0);
	gtk_text_view_set_editable (GTK_TEXT_VIEW (textAbout), FALSE);
	gtk_text_view_set_wrap_mode (GTK_TEXT_VIEW (textAbout), GTK_WRAP_WORD);

	const char *aboutStr = "Cheatah is a quick and dirty GTK/Linux front end to the Sword software.\n\nSword is developed by the CrossWire Software & Bible Society:\n\tP. O. Box 2528\n\tTempe, AZ  85280-2528\n\thttp://www.crosswire.org\n\nThis software is provided free for the study of God and His Word.";
	gtk_text_buffer_set_text(buffAbout, aboutStr, -1);

	gtk_widget_show_all(dialogAbout);		// "show_all" makes all the children visible too

	return;
}


void
on_lookupText_activated                  (GtkEntry     *entry,
                                        gpointer         data)
{
	cheatahWindow->lookupTextChanged();
}


void
on_searchButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
	cheatahWindow->searchButtonClicked();
}

void on_search_entry_activated(GtkEntry *entry, gpointer data)	{
	cheatahWindow->searchButtonClicked();
}


void
on_resultList_row_activated        (GtkTreeView *view, GtkTreePath *path, GtkTreeViewColumn *column, gpointer data)
{
	cheatahWindow->resultListRowActivated(view, path);
}


void on_arrow1_button_press_event(GtkButton       *button, gpointer         user_data) {
	cheatahWindow->navigateButtonClicked(0);
}


void on_arrow2_button_press_event(GtkButton       *button, gpointer         user_data) {
	cheatahWindow->navigateButtonClicked(1);
}


