// $Id: gtk_display.h 27 2006-07-17 13:13:16Z jonmmorgan $ ($URL: http://xsword.svn.sourceforge.net/svnroot/xsword/trunk/gtk_display.h $)
// vim:ts=4 sw=4
//
//  This program is released under the GNU GPL version 2.  For more licensing
//  information, see the file LICENSING.

#ifndef GTK_DISPLAY__H
#define GTK_DISPLAY__H

#include <gtk/gtk.h>
#include <swmgr.h>
#include <swdisp.h>

using sword::SWMgr;
using sword::SWModule;
using sword::SWDisplay;

// For internal use by GtkDisp - stores the tags for various formatting settings.
struct GtkDispTags	{
	GtkTextTag *verseNumber;
	GtkTextTag *currentVerse;
	GtkTextTagTable *table;
	// This cannot be a constructor, as it cannot be called before Gtk+ is initialised.
	void initialise(void);
};

class GtkDisp : public SWDisplay {
protected:
	GtkWidget *textView;
	GtkTextBuffer *textBuffer;
	// Having these static allows us to make changes that affect all Bible displays.
	static bool tags_initialised;
	static GtkDispTags tags;
public:

	static GtkWidget *new_text_view(void)	{
		if(!tags_initialised)	{
			tags.initialise();
			tags_initialised = true;
		}
		GtkTextBuffer *buff = gtk_text_buffer_new(tags.table);
		GtkWidget *textView = gtk_text_view_new_with_buffer(buff);
		return textView;
	}

	// Note that currently this textView must be allocated with
	// GtkDisp::new_text_view(), to prevent bad interactions with tags.
	GtkDisp(GtkWidget *textView);
	virtual char Display(SWModule &imodule)	= 0;
};

class GtkEntryDisp : public GtkDisp {
public:
	GtkEntryDisp(GtkWidget *textView) : GtkDisp(textView) {}
	virtual char Display(SWModule &imodule);
};

class GtkChapDisp : public GtkDisp {
public:
	GtkChapDisp(GtkWidget *textView) : GtkDisp(textView) {}
	virtual char Display(SWModule &imodule);
};

#endif
