// $Id: unicode.h 30 2006-11-18 04:54:34Z jonmmorgan $ ($URL: http://xsword.svn.sourceforge.net/svnroot/xsword/trunk/unicode.h $)
// vim:ts=4 sw=4
//
//  This program is released under the GNU GPL version 2.  For more licensing
//  information, see the file LICENSING.

// UTF-8 handling for Gtk+ 2.0.
#ifndef UNICODE__H
#define UNICODE__H

#include <ctype.h>
#include <gtk/gtk.h>
#include <stringmgr.h>
#include <swmodule.h>

using sword::StringMgr;
using sword::SWModule;

/* This class is required for Sword to support UTF-8.  UTF-8 is required by
   Gtk+ 2.x. */
class GtkStringMgr : public StringMgr {
public:
	/* Converts the param to an upper case Utf8 string. */
	virtual char* upperUTF8(char*, const unsigned int maxlen = 0);

	/* Converts the param to an uppercase latin1 string */
	virtual char* upperLatin1(char*);

protected:
	/* Enable Unicode support. */
	virtual bool supportsUnicode() const;

	/* This function checks whether a string is utf8 or not. */
	const bool isUtf8(const char *buf);
};

void text_buffer_insert_utf8_validate(GtkTextBuffer *buff, GtkTextIter *iter,
		const char *str, int len);

void text_buffer_insert_with_tag_utf8_validate(GtkTextBuffer *buff,
		GtkTextIter *iter, const char *str, int len, GtkTextTag *tag);

#endif
